<template>
  <VCard
    :class="horizontal && 'horizontal-card'"
    outlined
  >
    <VImg
      :height="height"
      :src="src"
    >
      <VBtn
        class="ma-3"
        fab
        small
      >
        <VIcon>mdi-plus</VIcon>
      </VBtn>
    </VImg>

    <VCardText>
      <p class="display-1">
        {{ title }}
      </p>

      <template v-if="stars">
        <VIcon
          v-for="(s, i) in stars"
          :key="`star-${i}`"
          color="warning"
        >
          mdi-{{ starType(parseFloat(s)) }}
        </VIcon>
      </template>

      <p>{{ subTitle }}</p>

      <template v-if="tags">
        <VChip
          v-for="(t, i) in tags"
          :key="`tag-${i}`"
          :class="['text-uppercase font-weight-medium', i > 0 && 'ml-3']"
        >
          {{ t }}
        </VChip>
      </template>
    </VCardText>

    <VCardActions v-if="!horizontal">
      <VSpacer />
      <VBtn
        :to="to"
        color="warning"
        text
        nuxt
      >
        Continuar
      </VBtn>
    </VCardActions>
  </VCard>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'nuxt-property-decorator';

@Component({
  methods: {
    starType(n: number) {
      switch (n) {
        case 1:
          return 'star';
        case 2:
          return 'star-half';
        default:
          return 'star-outline';
      }
    },
  },
})
export default class PostCurso extends Vue {
  @Prop(Boolean)
  readonly horizontal!: boolean

  @Prop({ default: '200px' })
  readonly height!: string

  @Prop(String)
  readonly src!: string

  @Prop(String)
  readonly to!: string

  @Prop(String)
  readonly title!: string

  @Prop(String)
  readonly subTitle!: string

  @Prop(Array)
  readonly stars!: number[]

  @Prop(Array)
  readonly tags!: string[]
}
</script>

<style lang="stylus" scoped>
.horizontal-card
  display flex
  flex-direction row
  .v-image
    height 100% !important
    flex auto
    border-radius 3px 0 0 3px !important
  .v-card__text
    min-width 280px
</style>
